<?php 
/*
* main component's model
*/

class model_component_core_menus extends model {

	/*
		
	*/
	public function get_menus_list() {
		return $this->dbh->query("SELECT m.*, COUNT(i.id) AS count FROM menus m LEFT JOIN menus_items i ON m.id = i.menu_id GROUP BY m.id");
	}
	
	public function get_menu($menu_id = 0) {
		return $this->dbh->row("SELECT * FROM menus WHERE id = '" . (int)$menu_id . "' LIMIT 1");
	}
	
	public function add_menu($data = array()) {
		$sql = "INSERT INTO menus (name, class)
							VALUES ('" . $this->dbh->escape($data['name']) . "', '" . $this->dbh->escape($data['class']) . "')";
		$this->dbh->exec($sql);
		return $this->dbh->lastInsertId();
	}
	
	public function edit_menu($data = array()) {
		$sql = "UPDATE menus SET 
					name = '" . $this->dbh->escape($data['name']) . "',
					class = '" . $this->dbh->escape($data['class']) . "'
				WHERE id = '" . (int)$data['id'] . "'";
		return $this->dbh->exec($sql);
	}
	
	public function delete_menu($menu_id = 0) {
		return $this->dbh->exec("DELETE FROM menus WHERE id = '" . (int)$menu_id . "'");
	}
	
	public function get_menu_item($item_id = 0) {
		return $this->dbh->row("SELECT * FROM menus_items WHERE id = '" . (int)$item_id . "' LIMIT 1");
	}
	
	public function get_menu_items($menu_id = 0, $params = array()) {
		$sql = "SELECT * FROM menus_items WHERE menu_id = '" . (int)$menu_id . "'";
		
		if(isset($params['parent_id'])) {
			$sql .= " AND parent_id = '" . (int)$params['parent_id'] . "'";
		}
		
		if(isset($params['sort'])) {
			$sql .= " ORDER BY " . $params['sort'] . " ";
		} else {
			$sql .= " ORDER BY menu_id DESC ";
		}
		
		if(isset($params['tree']) && $params['tree']===true) {
			$items = $this->dbh->query($sql);
			foreach($items as $i => $item) {
				$params['parent_id'] = $item['id'];
				$items[$i]['children'] = $this->get_menu_items($menu_id, $params);
			}
			return $items;
		}
		
		return $this->dbh->query($sql);
	}
	
	public function add_menu_item($data = array()) {
		$sql = "INSERT INTO menus_items (parent_id, menu_id, name, url, sort)
					VALUES ('" . (int)$data['parent_id'] . "', '" . (int)$data['menu_id'] . "', '" . $this->dbh->escape($data['name']) . "', '" . $this->dbh->escape($data['url']) . "', '" . (int)$data['sort'] . "')";
		$this->dbh->exec($sql);
		return $this->dbh->lastInsertId();
	}
	
	public function edit_menu_item($data = array()) {
		$sql = "UPDATE menus_items SET 
					menu_id = '" . (int)$data['menu_id'] . "',
					parent_id = '" . (int)$data['parent_id'] . "',
					name = '" . $this->dbh->escape($data['name']) . "',
					url = '" . $this->dbh->escape($data['url']) . "',
					sort = '" . (int)$data['sort'] . "'
				WHERE id = '" . (int)$data['id'] . "'";
				
		return $this->dbh->exec($sql);
	}
	
	public function delete_menu_item($item_id = 0) {
		$count_del = 0;
		$item = $this->get_menu_item($item_id);
		$children = $this->get_menu_items($item['menu_id'], array('parent_id' => $item_id));
		foreach($children as $child) {
			$count_del += (int)$this->delete_menu_item($child['id']);
		}
		$count_del += (int)$this->dbh->exec("DELETE FROM menus_items WHERE id = '" . (int)$item_id . "'");
		return $count_del;
	}
	
}