<?php 

/**
* класс менеджера модулей
*/
class controller_component_core_modules extends component {
	
	// вывод  активированных модулей
	public function action_index() {
		$this->data['success'] = '';
		if(isset($this->url['params']['success'])) {
			if($this->url['params']['success'] == 'deact') {
				$this->data['success'] = 'Модуль успешно деактивирован';
			} elseif($this->url['params']['success'] == 'act') {
				$this->data['success'] = 'Модуль успешно активирован';
			}
		}
		
		$this->data['modules_list'] = $this->model->get_activated_modules();
		//core::print_r($this->data['modules_list']);
		//core::print_r($this->url);

		$this->data['page_name'] = 'Активированные модули';
		$this->page['title'] = 'Активированные модули';
		$this->page['html'] = $this->load_view();

		return $this->page;
	}
	// вывод установленных модулей
	public function action_installed() {
		
		$this->data['modules_list'] = $this->model->get_installed_modules();
		$this->data['page_name'] = 'Установленные Модули';
		$this->page['title'] = 'Установленные Модули';
		$this->page['html'] = $this->load_view('installed');

		return $this->page;
	}
	// установка модулей
	public function action_install() {
		$this->data['errors'] = array();
		
		if(isset($_FILES['file'])) {
		
			$archive_types = array(
				'application/force-download',
				'application/x-zip-compressed',
				'application/zip'
			);
			
			if(!in_array($_FILES['file']['type'], $archive_types)) {
				$this->data['errors'][] = 'Для установки модуля необходим архив ZIP';
			}
			else {
				$zip = new ZipArchive;
				$zip->open($_FILES['file']['tmp_name']);
				if($zip->getFromName('install.php') === false) {
					$this->data['errors'][] = 'Файла install.php нет в архиве';
				}

				$zip->extractTo(ROOT_DIR . '/modules/');
				$zip->close();
				if(count($this->data['errors']) == 0) {
					//запускаем install.php
					require_once(ROOT_DIR . '/modules/install.php');
					//удаляем install.php
					unlink(ROOT_DIR . '/modules/install.php');
				}
			}
			if(empty($this->data['message']) AND (count($this->data['errors']) == 0) ) {
				$this->data['message'] = 'Сообщение об успешности установки не задано';
			}
		}

		$this->data['page_name'] = 'Установка модулей';
		$this->page['title'] = 'Установка модулей';
		$this->page['html'] = $this->load_view('install');

		return $this->page;
	}
	// обновление модуля
	public function action_update() {
		if(isset($_FILES['file'])) {
			if($_FILES['file']['type'] != 'application/zip') {
				$this->data['errors'][] = 'Для обновления модуля необходим архив ZIP';
			} 
			else {
				$zip = new ZipArchive;
				$zip->open($_FILES['file']['tmp_name']);
				if($zip->getFromName('update.php') === false) {
					$this->data['errors'][] = 'Файла update.php нет в архиве';
				}

				$zip->extractTo(ROOT_DIR . '/modules/');
				$zip->close();
				if(count($this->data['errors']) == 0) {
					//запускаем update.php
					require_once(ROOT_DIR . '/modules/update.php');
					//удаляем update.php
					unlink(ROOT_DIR . '/modules/update.php');
				}
			}
			if(empty($this->data['message']) AND (count($this->data['errors']) == 0) ) {
				$this->data['message'] = 'Сообщение об успешности обновления не задано';
			} 
		}

		$this->data['page_name'] = 'Обновление модуля';
		$this->page['title'] = 'Обновление модуля';
		$this->page['html'] = $this->load_view('update');

		return $this->page;
	}
	// активация модулей
	public function action_activate() {
		
		$module_info = $this->model->get_module_info($this->url['actions'][1]);
		$class_name = 'controller_' . $module_info['type'] . '_' . $module_info['dir'];	
		$obj = new $class_name($this->config, $this->url, $module_info['dir'], $this->dbh);
	
		$page = $obj->action_activate();
		$this->data['params'] = $page['html'];
		
		if(isset($_POST['activate'])) {
			
			$module['name'] = $_POST['name'];
			$module['type'] = $_POST['type'];
			$module['module_id'] = $this->url['actions'][1];
			$module['module_dir'] = $module_info['dir'];
			$module['position'] = $_POST['position'];
			$module['back_end'] = $_POST['back_end'];
			$module['sort'] = '1';
			/*
			if($_POST['page']==2) {
				// на всех кроме
			} else {
				// на выбранных
			}
			*/
			$module['params'] = isset($page['params']) ? $page['params'] : '';
			
			$num = $this->model->activate_module($module);

			$this->data['message'] = 'Модуль активирован';
		}
		

		$this->data['page_name'] = 'Активация модуля';
		$this->page['title'] = 'Активация модуля';
		$this->page['html'] = $this->load_view('activate');

		return $this->page;
	}
	
	// деактивация модулей
	public function action_deactivate() {
		if(isset($this->url['actions'][1])) {
			$module_info = $this->model->get_active_module_info($this->url['actions'][1]);
			$class_name = 'controller_' . $module_info['type'] . '_' . $module_info['module_dir'];	
			$obj = new $class_name($this->config, $this->url, $module_info['module_dir'], $this->dbh);
			
			if(method_exists($obj,'action_deactivate')) {
				$obj->action_deactivate($module_info);
			}
			$this->model->deactivate_module($this->url['actions'][1]);
			$this->redirect(SITE_URL . '/admin/modules/success=deact');
			
		} else {
			$this->redirect(SITE_URL . '/admin/modules');
		}
	}
	
	// найтройки модуля
	public function action_settings() {
		$this->data['errors'] = array();
		if(isset($this->url['params']['success'])) {
			if($this->url['params']['success']=='edited') {
				$this->data['message'] = 'Настройки модуля обновлены';
			}
		}
		
		$module_info = $this->model->get_active_module_info($this->url['actions'][1]);
		$class_name = 'controller_' . $module_info['type'] . '_' . $module_info['module_dir'];	
		$obj = new $class_name($this->config, $this->url, $module_info['module_dir'], $this->dbh);
		$page = array();
		if(method_exists($obj,'action_settings')) {
			$page = $obj->action_settings($module_info);
		}
			
		if(isset($_POST['edit_settings'])) {
			$data['id'] = $this->url['actions'][1];
			$data['name'] = $_POST['name'];
			$data['position'] = $_POST['position'];
			$data['back_end'] = $_POST['back_end'];
			$data['sort'] = '1';
			
			// если $obj->action_settings() вернул какие-то параметры, изменяем их в таблице. если нет, оставляем как есть, т.к. не во всех модулях есть необходимость изменять изначальные параметры при настройке
			$data['params'] = isset($page['params']) ? $page['params'] : false;
			if(!isset($page['errors']) || count($page['errors']) == 0 ) {
				$this->model->update_activated_module($data);
				$this->redirect(SITE_URL . '/admin/modules/settings/' . $this->url['actions'][1] . '/success=edited');
			} else {
				$this->data['errors'] = $page['errors'];
			}
			$this->data['module_info'] = array(
				'name' => $data['name'],
				'position' => $data['position'],
				'back_end' => (int)$data['back_end'],
				'sort' => (int)$data['sort'],
			);
		} else {
			$this->data['module_info'] = array(
				'name' => $module_info['name'],
				'position' => $module_info['position'],
				'back_end' => (int)$module_info['back_end'],
				'sort' => (int)$module_info['sort'],
			);
		}
		
		$this->data['params'] = $page['html'];
		
		$this->data['page_name'] = 'Редактирование модуля';
		$this->page['title'] = 'Редактирование модуля';
		$this->page['html'] = $this->load_view('settings');

		return $this->page;
	}
	
	public function action_delete() {
		if(isset($this->url['actions'][1])){
			$module_id = $this->url['actions'][1];
			$module = $this->model->get_module_info($module_id);
			$class_name = 'controller_' . $module['type'] . '_' . $module['dir'];
			$module_controller = new $class_name($this->config, $this->url, $module['name'], $this->dbh);
			
			if(method_exists($obj,'action_delete')) {
				return $module_controller->action_delete();
			} else {
				return array();
			}
		}
	}
}